
use std::convert::Infallible;
use std::path::PathBuf;

mod handle;

#[tokio::main]
async fn main() {
    let (tx, mut rx) = handle::spawn(Default::default());
    let _res = tokio::join![
	tokio::spawn(async move {
	    for file in ["./src/main.rs", "./src/handle.rs"]
	    {
		eprintln!("Sending {}", file);
		tx.send(std::path::Path::new(file).into()).await.unwrap();
	    }
	}),
	tokio::spawn(async move {
	    use futures::prelude::*;
	    while let Some((file, hash)) = rx.next().await {
		println!("Got file hash for {:?}: {:?}", file, hash);
	    }
	}),
    ];
    eprintln!("Done: {:?}", _res);
}
